using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Text;
using Microsoft.VisualBasic;

namespace ImeComposition
{

	//----------------------------------------------------------------
	//	 ϊCxgNX
	//----------------------------------------------------------------
	public class ConvertedEventArgs : EventArgs
	{
		private string yomi; // ǂ
		private bool	bSingle; // p
		private int		yomiLength = 0; // ǂ݂̕

		public ConvertedEventArgs( string f, bool singleFlag, int friLen ) {
			yomi = f;
			// result = r;
			bSingle = singleFlag;
			yomiLength = friLen;
		} // End Sub

		public string YomiString {
			get { return yomi; }
		}
		public int YomiLen {
			get { return yomiLength; }
		}

		public bool IsSingleChar {
			get { return bSingle; }
		}
	}

	//----------------------------------------------------------------
	// 	ǂ݂擾NX
	//----------------------------------------------------------------
	public class ImeYomiConversion
	{
		//----------------------------------------------------------------
		// 	[Jϐ
		//----------------------------------------------------------------
		private Control targetControl;			//	͂̃Rg[
		private Control targetYomiControl;	//	ǂ݂ZbgRg[

		private MsgListener msgListener;

#region IME API`

		private const int WM_CHAR = 0x102;

		private const int WM_IME_STARTCOMPOSITION  = 0x10D;
		private const int WM_IME_ENDCOMPOSITION  = 0x10E;
		private const int WM_IME_COMPOSITION = 0x10F;
		// WM_IME_COMPOSITION
		private const int GCS_COMPREADSTR  		= 0x0001;
		private const int GCS_COMPREADATTR		= 0x0002;
		private const int GCS_COMPREADCLAUSE	= 0x0004;
		private const int GCS_COMPSTR  				= 0x0008;
		private const int GCS_COMPATTR				= 0x0010;
		private const int GCS_COMPCLAUSE			= 0x0020;
		private const int GCS_CURSORPOS  			= 0x0080;
		private const int GCS_DELTASTART			= 0x0100;
		private const int GCS_RESULTREADSTR			= 0x0200;
		private const int GCS_RESULTREADCLAUSE	= 0x0400;
		private const int GCS_RESULTSTR  				= 0x0800;
		private const int GCS_RESULTCLAUSE			= 0x1000;

		private const int IMM_ERROR_NODATA	= -1;
		private const int IMM_ERROR_GENERAL = -2;

		//----------------------------------------------------------------
		// ReLXgnh̎擾
		//
		[DllImport("Imm32.dll")]
		private static extern int ImmGetContext( int hWnd );

		//----------------------------------------------------------------
		// ReLXgnh̊J
		//
		[DllImport("Imm32.dll")]
		private static extern int ImmReleaseContext( int hWnd, int hIMC );

		//----------------------------------------------------------------
		// IMEǂݓ̕擾
		//
		[DllImport("Imm32.dll")]
		private static extern int ImmGetCompositionString( int hIMC, int dwIndex, StringBuilder lpBuf, int dwBufLen );

		//----------------------------------------------------------------
		// IMȄԎ擾
		//
		[DllImport("Imm32.dll")]
		private static extern int ImmGetOpenStatus(int hIMC );

#endregion

		// targetCtrl ... {͂sRg[
		// yomiCtrl ... ǂ݂ZbgRg[
		public ImeYomiConversion( Control targetCtrl, Control yomiCtrl )
		{
			targetControl = targetCtrl;
			this.targetYomiControl = yomiCtrl;
				msgListener = new MsgListener( targetControl );
				msgListener.OnConverted += new MsgListener.Converted( eventConverted );
			//}
		}

		public bool Enabled {
			get {	return msgListener.Enabled;}		// bZ[WĎOn/Off
			set {	msgListener.Enabled = value;} // bZ[WĎ

		}

		// ǂ݂Rg[ɃZbg
		private void eventConverted( object sender, ConvertedEventArgs ea )
		{
			if( targetControl.Text.Length == 0 ) {
				// ͂̃Rg[Ȃǂ݂
				targetYomiControl.Text = "";
			}
			string s="";
			if( ea.IsSingleChar ) {
				s = ea.YomiString;
			} else {
				s = Strings.StrConv(ea.YomiString, VbStrConv.Wide, 0x411);
			}
			// ǂ݂Rg[ɃZbg
			targetYomiControl.Text += s;
		}

#region Window Message Listener
		// ͂̃Rg[ɑ郁bZ[W`FbN
		private class MsgListener	: NativeWindow
		{
			protected bool enabled = false; // bZ[W̊Ď(on/Off)
			public delegate void Converted( System.Object sender, ConvertedEventArgs e );
			public event Converted OnConverted;

			// RXgN^
			public MsgListener( Control c ) {
				AssignHandle( c.Handle );
				c.HandleDestroyed += new EventHandler( OnHandleDestroyed );
			}
			internal void OnHandleDestroyed(object sender, EventArgs e) {
				// Window was destroyed, release hook.
				ReleaseHandle();
			}

			public bool Enabled {
				get { return enabled; }
				set { enabled = value; }
			}

			//'----------------------------------------------------------------
			//' 	ǂݎ擾ΏۃRg[̃EBhEvV[W
			//'----------------------------------------------------------------
			protected override void WndProc( ref System.Windows.Forms.Message m )
			{
				int hIMC;
				int intLength;

				if( enabled ) {
					switch( m.Msg ) { // Select Case m.Msg
						case WM_IME_COMPOSITION:
							// string strResult = "";
							string strYomi	= "";
							if(((uint)m.LParam & (uint)GCS_RESULTREADSTR) != 0) {
								hIMC = ImmGetContext(this.Handle.ToInt32());
								// ǂ݂̕
								intLength = ImmGetCompositionString(hIMC, GCS_RESULTREADSTR, null, 0);
								if(intLength > 0) {
									StringBuilder temp = new StringBuilder(intLength);
									ImmGetCompositionString(hIMC, GCS_RESULTREADSTR, temp, intLength);
									strYomi = temp.ToString();
									if(strYomi.Length > intLength) {
										strYomi = strYomi.Substring(0, intLength);
									}
									// CxgN
									ConvertedEventArgs ea = new ConvertedEventArgs(strYomi, false, intLength);
									OnConverted(this, ea);
								}
								ImmReleaseContext(this.Handle.ToInt32(), hIMC);
							}
							break;

						case WM_CHAR:	// 'pp
							hIMC = ImmGetContext( this.Handle.ToInt32());
							if( ImmGetOpenStatus(hIMC) == 0 ) {
								char chr = Convert.ToChar(m.WParam.ToInt32() & 0xff);
								if( m.WParam.ToInt32() >= 32 ) {
									//CxgN
									string str = chr.ToString();
									ConvertedEventArgs ea = new ConvertedEventArgs( str, true, 1 );
									OnConverted( this , ea );
								}
							}
							ImmReleaseContext( this.Handle.ToInt32(), hIMC);
							break;
					}
				}
				base.WndProc( ref m);
			}
		} // End Class
#endregion
	}
}
